#include <bits/stdc++.h>

#define int long long
#define forn(i, n) for (int i = 0; i < (n); i++)
#define vint vector<int>
#define pb push_back

using namespace std;

vector<int> BFS(vector<vint > &g, int s) {
    vector<pair<bool, int>> used(g.size(), {false, -1});
    queue<int> q;
    used[s] = {true, 0};
    q.push(s);

    while (!q.empty()) {
        int x = q.front();
        q.pop();

        for (auto u: g[x]) {
            if (!used[u].first){
                used[u].first = true;
                used[u].second = used[x].second + 1;
                q.push(u);
            }
        }
    }

    vector<int> p;
    for (int i = 0; i < g.size(); i++){
        p.pb(used[i].second);
    }
    return p;
}

signed main() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<vint > g(n);
    for (int i = 0; i < (n - 1); i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].pb(b);
        g[b].pb(a);
    }
    if (t == 0) {
        vector<int> p = BFS(g, 0);
        sort(p.begin(), p.end());
        cout << p[n - 1 - k];
    }
    else {
        for (int i = 0; i < n; i++){
            vector<int> p = BFS(g, i);
            sort(p.begin(), p.end());
            cout << p[n - 1 - k] << ' ';
        }
    }
}
